'use strict';

/**
 * Module dependencies.
 */
var acl = require('acl');

// Using the memory backend
acl = new acl(new acl.memoryBackend());

/**
 * Invoke HostNames Permissions
 */
exports.invokeRolesPolicies = function () {
  acl.allow([{
    roles: ['admin'],
    allows: [{
      resources: '/api/hostNames',
      permissions: '*'
    }, {
      resources: '/api/hostNames/:hostType',
      permissions: '*'
    }, {
      resources: '/api/hostNames/:hostNameId',
      permissions: '*'
    }]
  }, {
    roles: ['user'],
    allows: [{
      resources: '/api/hostNames',
      permissions: ['get', 'post']
    }, {
      resources: '/api/hostNames/:hostType+envType',
      permissions: '*'
    }, {
      resources: '/api/hostNames/:hostNameId',
      permissions: ['get']
    }]
  }, {
    roles: ['guest'],
    allows: [{
      resources: '/api/hostNames',
      permissions: ['get']
    }, {
      resources: '/api/hostNames/:hostType+envType',
      permissions: 'get'
    }, {
      resources: '/api/hostNames/:hostNameId',
      permissions: ['get']
    }]
  }]);
};

/**
 * Check If HostNames Policy Allows
 */
exports.isAllowed = function (req, res, next) {
  var roles = (req.user) ? req.user.roles : ['guest'];

  // If an hostName is being processed and the current user created it then allow any manipulation
  if (req.hostName && req.user && req.hostName.user.id === req.user.id) {
    return next();
  }

  // Check for user roles
  acl.areAnyRolesAllowed(roles, req.route.path, req.method.toLowerCase(), function (err, isAllowed) {
    if (err) {
      // An authorization error occurred.
      return res.status(500).send('Unexpected authorization error');
    } else {
      if (isAllowed) {
        // Access granted! Invoke next middleware
        return next();
      } else {
        return res.status(403).json({
          message: 'User is not authorized'
        });
      }
    }
  });
};
